Builtin modules: Difference between revisions

From FreeCAD Documentation
Line 114: Line 114:
=== Main functions ===
=== Main functions ===


* activateWorkbench(string) - Activate the workbench by name
* '''activateWorkbench(string)''' - Activate the workbench by name
* activeDocument() - Return the active document or None if no one exists
* '''activeDocument()''' - Return the active document or None if no one exists
* activeWorkbench() - Return the active workbench object
* '''activeWorkbench()''' - Return the active workbench object
* addCommand(string, object) - Add a command
* '''addCommand(string, object)''' - Add a command
* addIcon(string, string or list) - Add an icon as file name or in XPM format to the system
* '''addIcon(string, string or list)''' - Add an icon as file name or in XPM format to the system
* addIconPath(string) - Add a new path to the system where to find icon files
* '''addIconPath(string)''' - Add a new path to the system where to find icon files
* addPreferencePage(string,string) - Add a UI form to the preferences dialog. The first argument specifies the file nameand the second specifies the group name
* '''addPreferencePage(string,string)''' - Add a UI form to the preferences dialog. The first argument specifies the file nameand the second specifies the group name
* addWorkbench(string, object) - Add a workbench under a defined name.
* '''addWorkbench(string, object)''' - Add a workbench under a defined name.
* createDialog(string) - Open a UI file
* '''createDialog(string)''' - Open a UI file
* getDocument(string) - Get a document by its name
* '''getDocument(string)''' - Get a document by its name
* getWorkbench(string) - Get the workbench by its name
* '''getWorkbench(string)''' - Get the workbench by its name
* insert(...) - Open a macro, Inventor or VRML file
* '''insert(...)''' - Open a macro, Inventor or VRML file
* listWorkbenches() - Show a list of all workbenches
* '''listWorkbenches() - Show a list of all workbenches
* open(...) - Open a macro, Inventor or VRML file
* '''open(...)''' - Open a macro, Inventor or VRML file
* removeWorkbench(string) - Remove the workbench with name
* '''removeWorkbench(string)''' - Remove the workbench with name
* runCommand(string) - Run command with name
* '''runCommand(string)''' - Run command with name
* updateGui() - Update the main window and all its windows
* '''updateGui()''' - Update the main window and all its windows


=== Selection sub-module ===
=== Selection sub-module ===


* addSelection(object) - Add an object to the selection
* '''addSelection(object)''' - Add an object to the selection
* clearSelection([string]) - Clear the selection to the given document name. If no document is given the complete selection is cleared.
* '''clearSelection([string])''' - Clear the selection to the given document name. If no document is given the complete selection is cleared.
* getSelection([string]) - Return a list of selected objects for a given document name. If no document is given the complete selection is returned.
* '''getSelection([string])''' - Return a list of selected objects for a given document name. If no document is given the complete selection is returned.
* isSelected(object) - Check if a given object is selected
* '''isSelected(object)''' - Check if a given object is selected
* removeSelection(object) - Remove an object from the selection
* '''removeSelection(object)''' - Remove an object from the selection


== Objects ==
== Objects ==

Revision as of 22:35, 30 May 2010

This page presents more in-depth information over the built-in FreeCAD modules, and what are the functions and properties availible to you. This page is not a complete list of all the contents of these modules, and, because of the fast evolution of FreeCAD, the information presented here might be slightly outdated, but it should give you a good overview of the possibilities. For complete list of the modules content, use the dir(module) function in the interpreter.

The FreeCAD module

This is the principal (root) module of FreeCAD. It can also be called by "App" from the FreeCAD interpreter. It contains everything that is needed to manipulate documents and their contents (objects).

Main Functions

These are the functions and attributes availible to you directly from the FreeCAD module.

  • ConfigDump() - Prints a dictionnnary containing all the FreeCAD configuration environment.
  • ConfigGet([string]) - Returns the value of the given key. If no key is given, the complete configuration is returned
  • ConfigSet(string, string) - Set the given key (first string) to the given value (second string).
  • Version() - Prints the FreeCAD version.
  • activeDocument() - Return the active document or None if there is no active document.
  • addExportType(string,string) - Adds a new export file type to FreeCAD. The first string must be formatted like this example: "Word Document (*.doc)". The second string is the name of a python script/module containing an export() function.
  • addImportType(string,string) - Adds a new import file type to FreeCAD, works the same way as addExportType.
  • closeDocument(string) - Closes the given document
  • getDocument(string) - Returns a document or raise an exception if there is no document with the given name.
  • getExportType(string) - Returns the name of the module that can export the specified filetype.
  • getImportType(string) - Returns the name of the module that can import the specified filetype.
  • listDocuments() - Returns a list of names of all documents.
  • newDocument([string]) - Creates and returns a new document with a given name. The document name must be unique, which is checked automatically. If no name is supplied, the document will be named "Untitled".
  • open(string) - See openDocument(string)
  • openDocument(string) - Creates and returns a document and load a project file into the document. The string argument must point to an existing file. If the file doesn't exist or the file cannot be loaded an I/O exception is thrown. In this case the created document is kept, but will be empty.
  • setActiveDocement(string) - Set the active document by its name.

Base sub-module

The Base module is contained inside the FreeCAD module and contains constructors for different types of objects heavily used in FreeCAD.

  • BoundBox([Xmin,Ymin,Zmin,Xmax,Ymax,Zmax]), or BoundBox(Tuple, Tuple), or BoundBox(Vector, Vector) - returns a bounding box. A bounding box is an orthographic cube which is a way to describe outer boundaries. You get a bounding box from a lot of 3D types. It is often used to check if a 3D entity lies in the range of another object. Checking for boundig interference first can save a lot of computing time!
  • Matrix() - returns a 4x4 matrix, that can be used to apply transformations to objects
  • Vector(x,y,z) - returns a FreeCAD 3D vector, representing a 3D point or a direction.

Vectors

Vectors can be created by one of the following manners:

v=FreeCAD.Vector()
v=FreeCAD.Vector(1,0,0)
v=FreeCAd.Base.Vector()

Methods:

  • Vector.Length() - returns the length of the vector
  • Vector.add(otherVector) - adds another vector to this one
  • Vector.cross(otherVector) - returns the crossproduct between two vectors
  • Vector.distanceToLine(Vector1,Vector2) - returns the distance between the vector and a line between Vector1 and Vector2
  • Vector.distanceToPlane(Vector1,Vector2) - returns the distance between the vector and a plane defined by a point and a normal
  • Vector.dot(otherVector) - returns the dot product between 2 vectors
  • Vector.getAngle(otherVector) - returns the angle in radians between 2 vectors
  • Vector.multiply(Float) - multiplies (scales) a vector by the given factor
  • Vector.normalize() - normalizes a vector (sets its length to 1.0)
  • Vector.projectToLine(Vector1,Vector2) - projects the vector on a line between Vector1 and Vector2
  • Vector.projectToPlane(Vector1,Vector2) - projects the vector on a plane defined by a point and a normal
  • Vector.scale(Float,Float,Float) - Same as multiply but lets specify different values for x, y and z directions
  • Vector.sub(otherVector) - subtracts another vector from the first one
  • Vector.x - returns the x coordinate of a vector
  • Vector.y - returns the y coordinate of a vector
  • Vector.z - returns the z coordinate of a vector

Matrixes

Matrixes can be created by one of the following manners:

m=FreeCAD.Matrix()
m=FreeCAD.Base.Matrix()

Methods:

  • Matrix.A() - The matrix elements
  • Matrix.A11() - The matrix elements
  • Matrix.A12() - The matrix elements
  • Matrix.A13() - The matrix elements
  • Matrix.A14() - The matrix elements
  • Matrix.A21() - The matrix elements
  • Matrix.A22() - The matrix elements
  • Matrix.A23() - The matrix elements
  • Matrix.A24() - The matrix elements
  • Matrix.A31() - The matrix elements
  • Matrix.A32() - The matrix elements
  • Matrix.A33() - The matrix elements
  • Matrix.A34() - The matrix elements
  • Matrix.A41() - The matrix elements
  • Matrix.A42() - The matrix elements
  • Matrix.A43() - The matrix elements
  • Matrix.A44() - The matrix elements
  • Matrix.determinant(Float) - Compute the determinant of the matrix
  • Matrix.inverse() - inverse() -> Matrix - Compute the inverse matrix, if possible
  • Matrix.invert() - Compute the inverse matrix, if possible
  • Matrix.move(Vector) - Move the matrix along the vector
  • Matrix.multiply(Matrix|Vector) - Multiply a matrix or vector with this matrix
  • Matrix.rotateX(Float) - rotate around X
  • Matrix.rotateY(Float) - rotate around Y
  • Matrix.rotateZ(Float) - rotate around Z
  • Matrix.scale(Vector) - Scales the matrix with the vector
  • Matrix.transform(Vector,Matrix) - return the dot product of the two vectors
  • Matrix.unity() - make this matrix to unity

Console sub-module

This contains methods to send text to FreeCAD's output console and status bar. The messages will have different color if they are message, warning or error.

  • GetStatus(...) - Get the status for either Log, Msg, Wrn or Error for an observer
  • PrintError(string) - Print an error message to the output
  • PrintLog(string) - Print a log message to the output
  • PrintMessage(string) - Print a message to the output
  • PrintWarning(string) - Print a warning to the output
  • SetStatus(...) - Set the stats for either Log, Msg, Wrn or Error for an observer

The FreeCADGui Module

Main functions

  • activateWorkbench(string) - Activate the workbench by name
  • activeDocument() - Return the active document or None if no one exists
  • activeWorkbench() - Return the active workbench object
  • addCommand(string, object) - Add a command
  • addIcon(string, string or list) - Add an icon as file name or in XPM format to the system
  • addIconPath(string) - Add a new path to the system where to find icon files
  • addPreferencePage(string,string) - Add a UI form to the preferences dialog. The first argument specifies the file nameand the second specifies the group name
  • addWorkbench(string, object) - Add a workbench under a defined name.
  • createDialog(string) - Open a UI file
  • getDocument(string) - Get a document by its name
  • getWorkbench(string) - Get the workbench by its name
  • insert(...) - Open a macro, Inventor or VRML file
  • listWorkbenches() - Show a list of all workbenches
  • open(...) - Open a macro, Inventor or VRML file
  • removeWorkbench(string) - Remove the workbench with name
  • runCommand(string) - Run command with name
  • updateGui() - Update the main window and all its windows

Selection sub-module

  • addSelection(object) - Add an object to the selection
  • clearSelection([string]) - Clear the selection to the given document name. If no document is given the complete selection is cleared.
  • getSelection([string]) - Return a list of selected objects for a given document name. If no document is given the complete selection is returned.
  • isSelected(object) - Check if a given object is selected
  • removeSelection(object) - Remove an object from the selection

Objects

  • Axis
  • Content
  • Label
  • Location
  • Name
  • Placement
  • Pos
  • PropertiesList
  • Shape
  • State
  • Type
  • ViewObject
  • getAllDerivedFrom
  • getDocumentationOfProperty
  • getGroupOfProperty
  • getPropertyByName
  • getTypeOfProperty
  • isDerivedFrom
  • touch

View Objects

  • Annotation
  • BoundingBox
  • Content
  • ControlPoints
  • DisplayMode
  • LineColor
  • LineMaterial
  • LineWidth
  • Objectt
  • PointColor
  • PointMaterial
  • PointSize
  • PropertiesList
  • RootNode
  • ShapeColor
  • ShapeMaterial
  • Transparency
  • Type
  • Visibility
  • getAllDerivedFrom
  • getDocumentationOfProperty
  • getGroupOfProperty
  • getPropertyByName
  • getTypeOfProperty
  • hide
  • isDerivedFrom
  • isVisible
  • listDisplayModes
  • show
  • toString
  • update